package ListCategoryFolder::CMS;

use strict;

sub list_category {
    my ($cb, $app, $template) = @_;

    return if !$app->blog;

    my $old;
    my $new;

    $old = <<HTML;
<mt:include name="include/header.tmpl">
HTML
    $old = quotemeta($old);

    if ( MT->version_number =~ /^5\.2/ || MT->version_number =~ /^6\./ ) {
        $new = <<HTML;
<mt:setvarblock name="js_include" append="1">
<script>
function createItem2(id, parent, label, basename, number) {
 var line = '<span class="sort-tab"></span>';
 line += '<span class="item-label">'+label+'</span>';
 if ( basename )
   line += '<span class="item-basename"><span class="item-basename-text">'+basename+'</span></span>';
 line += ' <span class="item-ctrl"></span>';
 line += ' <span class="count">'+number+'</span>';
 var \$item = jQuery('<div id="cat-'+id+'" class="pcat-'+parent+'" />').append(line);
 return \$item;
}
function initItem2(\$item) {
 \$item.find('.item-ctrl').append('<a href="javascript:void(0)" class="item-action fold clickable"><__trans_section component="ListCategoryFolder"><__trans phrase="Fold" escape="js"></__trans_section></a>');
 fold();
}
function renderItems2(data) {
 var objs = data.result.objects;
 var count = objs.length;
 for (var i = 0; i < count; i++) {
   var id = parseInt(objs[i][0]);
   var parent = parseInt(objs[i][1]);
   var label = objs[i][2];
   var basename = objs[i][3];
   var number = objs[i][4]
   var \$item = createItem2(id, parent, label, basename, number);
   initItem2(\$item);
 }
}
function fold() {
 jQuery('.fold').off('click');
 jQuery('.fold').on('click', function(){
     var index = jQuery(this).parent().parent().index();
     var size = jQuery('.pcat-0').size() - 1;
     var item = jQuery(this).parent().parent();
     var flag = 1;
     if (index == size) {
         flag = 0;
     }
     var action;
     var parent_margin = item.css('margin-left');
     parent_margin = parent_margin.match(/\\d+/);
     while (flag) {
         item = item.next();
         var next_margin = item.css('margin-left');
         next_margin = next_margin.match(/\\d+/);
         if (next_margin != 0 && (parseInt(parent_margin,10) < parseInt(next_margin,10))) {
             if (action == 'h') {
                 item.hide();
             } else if (action == 's') {
                 item.show();
             } else {
                 if (item.css('display') == 'none') {
                     item.show();
                     action = 's';
                 } else {
                     item.hide();
                     action = 'h';
                 }
             }
         } else {
             flag = 0;
         }
         index++;
         if (index == size) {
             flag = 0;
         }
     }
 });
}
</script>
</mt:setvarblock>
<mt:include name="include/header.tmpl">
HTML

    } elsif ( MT->version_number > 5.1 ) {

        $new = <<HTML;
<mt:setvarblock name="js_include" append="1">
<script>
function createItem(id, parent, label, basename, number) {
  var line = '<span class="sort-tab"></span>';
  line += '<span class="item-label">'+label+'</span>';
  if ( basename )
    line += '<span class="item-basename"><span class="item-basename-text">'+basename+'</span></span>';
  line += ' <span class="item-ctrl"></span>';
  line += ' <span class="count">'+number+'</span>';
  var \$item = jQuery('<div id="'+id+'" class="'+parent+'" />').append(line);
  return \$item;
}
function initItem2(\$item) {
 \$item.find('.item-ctrl').append('<a href="javascript:void(0)" class="item-action fold clickable"><__trans_section component="ListCategoryFolder"><__trans phrase="Fold" escape="js"></__trans_section></a>');
 fold();
}
function renderItems2(data) {
 var objs = data.result.objects;
 var count = objs.length;
 for (var i = 0; i < count; i++) {
   var id = parseInt(objs[i][0]);
   var parent = parseInt(objs[i][1]);
   var label = objs[i][2];
   var basename = objs[i][3];
   var number = objs[i][4]
   var \$item = createItem2(id, parent, label, basename, number);
   initItem2(\$item);
 }
}
function fold() {
 jQuery('.fold').unbind('click');
 jQuery('.fold').bind('click', function(){
     var index = jQuery(this).parent().parent().index();
     var size = jQuery('.0').size() - 1;
     var item = jQuery(this).parent().parent();
     var flag = 1;
     if (index == size) {
         flag = 0;
     }
     var action;
     var parent_margin = item.css('margin-left');
     parent_margin = parent_margin.match(/\\d+/);
     while (flag) {
         item = item.next();
         var next_margin = item.css('margin-left');
         next_margin = next_margin.match(/\\d+/);
         if (next_margin != 0 && (parseInt(parent_margin,10) < parseInt(next_margin,10))) {
             if (action == 'h') {
                 item.hide();
             } else if (action == 's') {
                 item.show();
             } else {
                 if (item.css('display') == 'none') {
                     item.show();
                     action = 's';
                 } else {
                     item.hide();
                     action = 'h';
                 }
             }
         } else {
             flag = 0;
         }
         index++;
         if (index == size) {
             flag = 0;
         }
     }
 });
}
</script>
</mt:setvarblock>
<mt:include name="include/header.tmpl">
HTML
    }

    $$template =~ s/$old/$new/;

    $old = <<HTML;
initItem(\$item);
HTML
    $old = quotemeta($old);

    $new = <<HTML;
initItem(\$item);
initItem2(\$item);
HTML

    $$template =~ s/$old/$new/g;

    $old = <<HTML;
initItem(\$this);
HTML
    $old = quotemeta($old);

    $new = <<HTML;
initItem(\$this);
initItem2(\$this);
HTML

    $$template =~ s/$old/$new/g;

    $old = <<HTML;
     renderItems(data);
     setDirty(false);
HTML
    $old = quotemeta($old);

    $new = <<HTML;
     renderItems(data);
     renderItems2(data);
     setDirty(false);
HTML

    $$template =~ s/$old/$new/g;

    $old = <<HTML;
function bulkUpdateCategories() {
HTML
    $old = quotemeta($old);

    if ( MT->version_number =~ /^5\.2/ || MT->version_number =~ /^6\./ ) {
        $new = <<HTML;
function bulkUpdateCategories() {
  jQuery('.pcat-0').each(function(){
    if (jQuery(this).index() != 0) {
      jQuery(this).css('display', 'block');
    }
  });
HTML

    } elsif ( MT->version_number > 5.1 ) {

        $new = <<HTML;
function bulkUpdateCategories() {
  jQuery('.0').each(function(){
    if (jQuery(this).index() != 0) {
      jQuery(this).css('display', 'block');
    }
  });
HTML

    }

    $$template =~ s/$old/$new/g;
}

1;
